apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "worker.fullname" $ }}
  labels:
  {{- include "worker.labels" $ | nindent 4 }}
spec:
  replicas: {{ .Values.replicas | default 1 }}
  selector:
    matchLabels:
      app: {{ include "worker.fullname" $ | kebabcase }}
    {{- include "worker.selectorLabels" $ | nindent 6 }}
  template:
    metadata:
      labels:
        app: {{ include "worker.fullname" $ | kebabcase }}
        loggingFormat: "json"
      {{- include "worker.selectorLabels" $ | nindent 8 }}
    spec:
      imagePullSecrets: 
      {{- toYaml  $.Values.imagePullSecrets | nindent 8 }}
      initContainers: 
      {{- toYaml  $.Values.initContainers | nindent 8 }}
      volumes:
      - name: tmp-volume
        emptyDir: {}
      containers:
      - env:
        - name: AMQP_HOST
          value: {{ .Values.amqp.host }}
        - name: AMQP_PROTOCOL
          value: {{ .Values.amqp.protocol | quote }}
        - name: AMQP_PORT
          value: {{ .Values.amqp.port | quote }}
        - name: AMQP_USER
          value: {{ .Values.amqp.user | quote }}
        - name: AMQP_PASS
          value: {{ .Values.amqp.pass | quote }}
        - name: EXCHANGE
          value: {{ .Values.amqp.exchange | quote }}
        - name: MINIO_HOST
          value: {{ .Values.minio.host | quote }}
        - name: MINIO_PORT
          value: {{ .Values.minio.port | quote }}
        - name: MINIO_ACCESS_KEY
          value: {{ .Values.minio.accessKey | quote }}
        - name: MINIO_SECRET_KEY
          value: {{ .Values.minio.secretKey | quote }}
        - name: MINIO_USE_SSL
          value: {{ .Values.minio.useSSL | quote }}
        image: {{ $.Values.image.repository }}:{{ $.Values.image.tag | default $.Chart.AppVersion }}
        imagePullPolicy: {{ $.Values.imagePullPolicy }}
        volumeMounts:
        - mountPath: /tmp
          name: tmp-volume
        securityContext:
          seLinuxOptions: null
          runAsUser: 1001
          runAsGroup: 1001
          runAsNonRoot: true
          privileged: false
          readOnlyRootFilesystem: true
          allowPrivilegeEscalation: false
          capabilities:
            drop:
              - ALL
          seccompProfile:
            type: RuntimeDefault
        name: {{ include "worker.fullname" $ | kebabcase }}
        ports:
        - containerPort: 3000
        resources: 
        {{- toYaml $.Values.resources | nindent 10 }}

---
apiVersion: v1
kind: Service
metadata:
  name: {{ include "worker.fullname" $ }}-svc
  labels:
  {{- include "worker.labels" $ | nindent 4 }}
spec:
  type: {{ $.Values.workerService.type }}
  selector:
    app: {{ include "worker.fullname" $ | kebabcase }}
  {{- include "worker.selectorLabels" $ | nindent 4 }}
  ports:
	{{- $.Values.workerService.ports | toYaml | nindent 2 -}}
